import request from '~/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsArticleComment, CmsArticleCommentParam } from './model';


/**
 * 分页查询文章评论表
 */
export async function pageCmsArticleComment(params: CmsArticleCommentParam) {
  const res = await request.get<ApiResult<PageResult<CmsArticleComment>>>(
    '/cms/cms-article-comment/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询文章评论表列表
 */
export async function listCmsArticleComment(params?: CmsArticleCommentParam) {
  const res = await request.get<ApiResult<CmsArticleComment[]>>(
    '/cms/cms-article-comment',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加文章评论表
 */
export async function addCmsArticleComment(data: CmsArticleComment) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-article-comment',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改文章评论表
 */
export async function updateCmsArticleComment(data: CmsArticleComment) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-article-comment',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除文章评论表
 */
export async function removeCmsArticleComment(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-article-comment/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除文章评论表
 */
export async function removeBatchCmsArticleComment(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-article-comment/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询文章评论表
 */
export async function getCmsArticleComment(id: number) {
  const res = await request.get<ApiResult<CmsArticleComment>>(
    '/cms/cms-article-comment/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
